// This file is autogenerated, see scripts/prebuild.ts
import { SidebarItem } from "vocs";

export const accountKitReactReferenceSidebar: SidebarItem[] = [
  {
    text: "@account-kit/react",
    items: [
      {
        text: "Overview",
        link: "/reference/account-kit/react",
      },
    ],
  },
  {
    text: "Components",
    items: [
      {
        text: "AlchemyAccountProvider",
        link: "/reference/account-kit/react/components/AlchemyAccountProvider",
      },
      {
        text: "AuthCard",
        link: "/reference/account-kit/react/components/AuthCard",
      },
      {
        text: "Dialog",
        link: "/reference/account-kit/react/components/Dialog",
      },
    ],
  },
  {
    text: "Authentication",
    items: [
      {
        text: "useAddPasskey",
        link: "/reference/account-kit/react/hooks/useAddPasskey",
      },
      {
        text: "useAuthModal",
        link: "/reference/account-kit/react/hooks/useAuthModal",
      },
      {
        text: "useAuthenticate",
        link: "/reference/account-kit/react/hooks/useAuthenticate",
      },
      {
        text: "useConnect",
        link: "/reference/account-kit/react/hooks/useConnect",
      },
      {
        text: "useExportAccount",
        link: "/reference/account-kit/react/hooks/useExportAccount",
      },
      {
        text: "useLogout",
        link: "/reference/account-kit/react/hooks/useLogout",
      },
      {
        text: "useSigner",
        link: "/reference/account-kit/react/hooks/useSigner",
      },
      {
        text: "useSignerStatus",
        link: "/reference/account-kit/react/hooks/useSignerStatus",
      },
      {
        text: "useUser",
        link: "/reference/account-kit/react/hooks/useUser",
      },
    ],
  },
  {
    text: "Account Client",
    items: [
      {
        text: "useAccount",
        link: "/reference/account-kit/react/hooks/useAccount",
      },
      {
        text: "useSmartAccountClient",
        link: "/reference/account-kit/react/hooks/useSmartAccountClient",
      },
    ],
  },
  {
    text: "Smart Account Actions",
    items: [
      {
        text: "useChain",
        link: "/reference/account-kit/react/hooks/useChain",
      },
      {
        text: "useClientActions",
        link: "/reference/account-kit/react/hooks/useClientActions",
      },
      {
        text: "useDropAndReplaceUserOperation",
        link: "/reference/account-kit/react/hooks/useDropAndReplaceUserOperation",
      },
      {
        text: "useSendUserOperation",
        link: "/reference/account-kit/react/hooks/useSendUserOperation",
      },
      {
        text: "useSignMessage",
        link: "/reference/account-kit/react/hooks/useSignMessage",
      },
      {
        text: "useSignTypedData",
        link: "/reference/account-kit/react/hooks/useSignTypedData",
      },
      {
        text: "useWaitForUserOperationTransaction",
        link: "/reference/account-kit/react/hooks/useWaitForUserOperationTransaction",
      },
    ],
  },
  {
    text: "Bundler/RPC Client",
    items: [
      {
        text: "useBundlerClient",
        link: "/reference/account-kit/react/hooks/useBundlerClient",
      },
    ],
  },
  {
    text: "Utilities",
    items: [
      {
        text: "useAlchemyAccountContext",
        link: "/reference/account-kit/react/hooks/useAlchemyAccountContext",
      },
      {
        text: "useAuthError",
        link: "/reference/account-kit/react/hooks/useAuthError",
      },
      {
        text: "useConnection",
        link: "/reference/account-kit/react/hooks/useConnection",
      },
      {
        text: "useUiConfig",
        link: "/reference/account-kit/react/hooks/useUiConfig",
      },
    ],
  },
  {
    text: "Functions",
    items: [
      {
        text: "createConfig",
        link: "/reference/account-kit/react/functions/createConfig",
      },
    ],
  },
  {
    text: "Classes",
    items: [
      {
        text: "NoAlchemyAccountContextError",
        items: [
          {
            text: "constructor",
            link: "/reference/account-kit/react/classes/NoAlchemyAccountContextError/constructor",
          },
        ],
      },
    ],
  },
  {
    text: "Resources",
    items: [
      {
        text: "Third Party",
        items: [
          {
            text: "Bundlers",
            link: "/third-party/bundlers",
          },
          {
            text: "Chains",
            link: "/third-party/chains",
          },
          {
            text: "Paymasters",
            link: "/third-party/paymasters",
          },
          {
            text: "Signers",
            link: "/third-party/signers",
          },
          {
            text: "Smart Contracts",
            link: "/third-party/smart-contracts",
          },
        ],
        collapsed: true,
      },
      {
        text: "Terms",
        link: "/resources/terms",
      },
      {
        text: "Types",
        link: "/resources/types",
      },
      {
        text: "FAQs",
        link: "/resources/faqs",
      },
      {
        text: "Contact us",
        link: "/resources/contact-us",
      },
    ],
  },
];
